> This page is for Developer Documentation.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.benchling.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.benchling.com/_mcp/server.

# Complete multi-part blob upload

POST https://{tenant_name}.benchling.com/api/v2/blobs/{blob_id}:complete-upload
Content-Type: application/json


Combine blob parts into a single blob.

## Multipart Upload

If a blob is larger than 10MB, it should be uploaded in multiple parts using the following endpoints:
- [Start a multi-part blob upload](#/Blobs/createMultipartBlob)
- [Upload a blob part](#/Blobs/createBlobPart)
- [Complete a blob upload](#/Blobs/completeMultipartBlob)

Each part must be at least 5MB in size, except for the last part. We recommend keeping each part to under 10MB when uploading.

Each part has a *partNumber* and an *eTag*. The part number can be any number between 1 to 10,000, inclusive - this number should be unique and identifies the order of the part in the final blob. The eTag of a part is returned in the API response - this eTag must be specified when completing the upload in order to ensure the server has received all the expected parts.


Reference: https://docs.benchling.com/docs/api/v2/benchling-api/blobs/complete-multipart-blob

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `blob_id` (string, required)

### Body (application/json)

This endpoint expects a BlobComplete.

- `parts` (list of BlobPart, optional)

## Response

### 200

Created

- `id` (string, optional) — The universally unique identifier (UUID) for the blob.
- `mimeType` (string, optional) — eg. application/jpeg
- `name` (string, optional) — Name of the blob
- `type` (enum, optional) — One of RAW_FILE or VISUALIZATION. If VISUALIZATION, the blob may be displayed as an image preview.
  - Allowed values: `RAW_FILE`, `VISUALIZATION`
- `uploadStatus` (enum, optional)
  - Allowed values: `IN_PROGRESS`, `COMPLETE`, `ABORTED`

## Errors

### 400 Bad Request Error

Bad Request

- `error` (BadRequestErrorError, optional)

## Types

### BlobPart

- `eTag` (string, optional)
- `partNumber` (integer, optional)

### BadRequestErrorError

- `message` (string, optional)
- `type` (enum, optional)
  - Allowed values: `invalid_request_error`
- `userMessage` (string, optional)

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "id": "c33fe52d-fe6a-4c98-adcd-211bdf6778f7",
  "mimeType": "text/csv",
  "name": "MyInstrumentInputFile.csv",
  "type": "RAW_FILE",
  "uploadStatus": "IN_PROGRESS"
}
```

**SDK Code**

```python
import requests

url = "https://{tenant_name}.benchling.com/api/v2/blobs/blob_id:complete-upload"

payload = {}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://{tenant_name}.benchling.com/api/v2/blobs/blob_id:complete-upload';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```